=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2010-07-18 03:48:41 +0000
+++ bzrlib/errors.py	2010-07-19 15:11:18 +0000
@@ -1177,20 +1177,17 @@
 
 class InvalidRevisionSpec(BzrError):
 
+    _fmt = ("Requested revision: '%(spec)s' does not exist in branch:"
+            " %(branch_url)s%(extra)s")
+
     def __init__(self, spec, branch, extra=None):
         BzrError.__init__(self, branch=branch, spec=spec)
+        self.branch_url = getattr(branch, 'user_url', str(branch))
         if extra:
             self.extra = '\n' + str(extra)
         else:
             self.extra = ''
 
-    def __str__(self):
-        _fmt = ("Requested revision: '%s' does not exist in branch:"
-                " %s%s"
-                % (self.spec, self.branch.user_url, self.extra))
-
-        return str(_fmt)
-
 
 class HistoryMissing(BzrError):
 

